package gstests.tutorials;

/*
Using AssertJ Swing to do Java GUI testing (of swing classes)
- Obtain from: https://search.maven.org/search?q=assertj-swing-junit
- Documentation: https://joel-costigliola.github.io/assertj/assertj-swing.html

Alternatives to AssertJSwing:
https://sqa.stackexchange.com/questions/18554/open-source-tools-for-automation-of-java-gui-application-testing

Event Dispatch Thread (EDT) pages:
- https://web.archive.org/web/20120526191520/http://alexruiz.developerblogs.com/?p=160
- https://web.archive.org/web/20130218063544/http://weblogs.java.net/blog/alexfromsun/archive/2006/02/debugging_swing.html

*/

import org.junit.AfterClass;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import org.greenstone.gatherer.GathererProg; // main GLI class we'll be testing

import org.assertj.swing.junit.testcase.AssertJSwingJUnitTestCase;
import org.assertj.swing.fixture.FrameFixture;
import org.assertj.swing.edt.GuiActionRunner;

// static imports
import static org.assertj.swing.launcher.ApplicationLauncher.*;


public class RunGLITest extends AssertJSwingJUnitTestCase {
  private FrameFixture window;

  @Override
  protected void onSetUp() {
    GathererProg frame = GuiActionRunner.execute(() -> new GathererProg());
    // IMPORTANT: note the call to 'robot()'
    // we must use the Robot from AssertJSwingJUnitTestCase
    
    //window = new FrameFixture(robot(), frame);
    //window.show(); // shows the frame to test

    // Launch GathererProg.java's main() method
    // See https://joel-costigliola.github.io/assertj/assertj-swing-launch.html

    String GSDLOS = System.getenv("GSDLOS");
    String GSDLHOME = System.getenv("GSDLHOME");
    String GSDL3HOME = System.getenv("GSDL3HOME");
    String GSDL3SRCHOME = System.getenv("GSDL3SRCHOME");
    application("org.greenstone.gatherer.GathererProg").withArgs(
								 "-gsdl", GSDLHOME,
								 "-gsdlos", GSDLOS,
								 "-gsdl3", GSDL3HOME,
								 "-gsdl3src", GSDL3SRCHOME).start();
  }

  @Test
  public void shouldCopyTextInLabelWhenClickingButton() {
      System.err.println("@@@ First test");
      //window.textBox("textToCopy").enterText("Some random text");
      //window.button("copyButton").click();
      //window.label("copiedText").requireText("Some random text");
  }
}
